searchNodes=[{"doc":"Library to access Odoo JSON-RPC API from Elixir. Provides the following methods for interacting with Odoo: login search search_read read read_group create write delete execute","ref":"Odoo.html","title":"Odoo","type":"module"},{"doc":"Create objects Return {:ok, new_object_id} or {:error, message} Example iex&gt; { :ok , product_id } = Odoo . create ( odoo , &quot;product.product&quot; , [ name : &quot;mi mega producto3&quot; ] ) { :ok , 63 } You can specify the context language to create the object in the desired language. iex(44)&gt; { :ok , result } = Odoo . create ( odoo , &quot;product.product&quot; , [ name : &quot;Product2&quot; ] , [ lang : &quot;en_US&quot; ] ) { :ok , % Odoo.Result { data : 185 , model : &quot;product.product&quot; , opts : [ name : &quot;Product2&quot; ] } }","ref":"Odoo.html#create/3","title":"Odoo.create/3","type":"function"},{"doc":"Delete objects by id ### Example iex(10)&gt; { :ok , result } = Odoo . delete odoo , &quot;product.template&quot; , [ 116 ] { :ok , % Odoo.Result { data : true , model : &quot;product.template&quot; , opts : &#39;t&#39; } } ` ` `","ref":"Odoo.html#delete/3","title":"Odoo.delete/3","type":"function"},{"doc":"Execute a method on a model (call to api odoo). Confirm a sale order with id 3 iex&gt; {:ok, res2} = Odoo.execute(odoo, &quot;sale.order&quot;, &quot;action_confirm&quot;, [3]) {:ok, %Odoo.Result{data: true, model: &quot;sale.order&quot;, opts: [3]}}","ref":"Odoo.html#execute/4","title":"Odoo.execute/4","type":"function"},{"doc":"Login in Odoo and set session_id for future calls Params (required) user: string Odoo user password: string Odoo password database: string Odoo database url: string Odoo url, http or https Example iex&gt; { :ok , odoo } = Odoo . login ( &quot;admin&quot; , &quot;admin&quot; , &quot;mydatabasename&quot; , &quot;https://mydatabasename.odoo.com&quot; ) { :ok , % Odoo.Session { cookie : &quot;session_id=c8e544d0b305920adgsfdfdsa7b0cfe; Expires=Fri, 06-May-2022 23:16:12 GMT; Max-Age=7776000; HttpOnly; Path=/&quot; , database : &quot;mydatabasename&quot; , password : &quot;admin&quot; , url : &quot;https://mydatabasename.odoo.com&quot; , user : &quot;admin&quot; , user_context : %{ &quot;lang&quot; =&gt; &quot;en_US&quot; , &quot;tz&quot; =&gt; &quot;Asia/Calcutta&quot; , &quot;uid&quot; =&gt; 2 } } }","ref":"Odoo.html#login/4","title":"Odoo.login/4","type":"function"},{"doc":"Pagination over results in search_read (call to api odoo) Example iex&gt; { :ok , result } = Odoo . search_read ( ...&gt; odoo , &quot;product.product&quot; , limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 1 , &quot;name&quot; =&gt; &quot;Restaurant Expenses&quot; } , %{ &quot;id&quot; =&gt; 2 , &quot;name&quot; =&gt; &quot;Hotel Accommodation&quot; } , %{ &quot;id&quot; =&gt; 3 , &quot;name&quot; =&gt; &quot;Virtual Interior Design&quot; } , %{ &quot;id&quot; =&gt; 4 , &quot;name&quot; =&gt; &quot;Virtual Home Staging&quot; } , %{ &quot;id&quot; =&gt; 5 , &quot;name&quot; =&gt; &quot;Office Chair&quot; } ] , model : &quot;product.product&quot; , opts : [ limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ] } } iex&gt; { :ok , result2 } = Odoo . next ( odoo , result ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 6 , &quot;name&quot; =&gt; &quot;Office Lamp&quot; } , %{ &quot;id&quot; =&gt; 7 , &quot;name&quot; =&gt; &quot;Office Design Software&quot; } , %{ &quot;id&quot; =&gt; 8 , &quot;name&quot; =&gt; &quot;Desk Combination&quot; } , %{ &quot;id&quot; =&gt; 9 , &quot;name&quot; =&gt; &quot;Customizable Desk&quot; } , %{ &quot;id&quot; =&gt; 10 , &quot;name&quot; =&gt; &quot;Customizable Desk&quot; } ] , model : &quot;product.product&quot; , opts : [ offset : 5 , limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ] } }","ref":"Odoo.html#next/2","title":"Odoo.next/2","type":"function"},{"doc":"Get previous page results (call to api odoo) Example iex&gt; { :ok , odoo } = Odoo . login ( ...&gt; &quot;admin&quot; , &quot;admin&quot; , &quot;mydatabasename&quot; , &quot;https://mydatabasename.odoo.com&quot; ) { :ok , % Odoo.Session { cookie : &quot;session_id=c8e544d0b305920afgdgsfdfdsa7b0cfe; Expires=Fri, 06-May-2022 23:16:12 GMT; Max-Age=7776000; HttpOnly; Path=/&quot; , database : &quot;mydatabasename&quot; , password : &quot;admin&quot; , url : &quot;https://mydatabasename.odoo.com&quot; , user : &quot;admin&quot; , user_context : %{ &quot;lang&quot; =&gt; &quot;en_US&quot; , &quot;tz&quot; =&gt; &quot;Asia/Calcutta&quot; , &quot;uid&quot; =&gt; 2 } } } iex&gt; { :ok , result } = Odoo . search_read ( ...&gt; odoo , &quot;product.product&quot; , limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 1 , &quot;name&quot; =&gt; &quot;Restaurant Expenses&quot; } , %{ &quot;id&quot; =&gt; 2 , &quot;name&quot; =&gt; &quot;Hotel Accommodation&quot; } , %{ &quot;id&quot; =&gt; 3 , &quot;name&quot; =&gt; &quot;Virtual Interior Design&quot; } , %{ &quot;id&quot; =&gt; 4 , &quot;name&quot; =&gt; &quot;Virtual Home Staging&quot; } , %{ &quot;id&quot; =&gt; 5 , &quot;name&quot; =&gt; &quot;Office Chair&quot; } ] , model : &quot;product.product&quot; , opts : [ limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ] } } iex&gt; { :ok , result2 } = Odoo . next ( odoo , result ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 6 , &quot;name&quot; =&gt; &quot;Office Lamp&quot; } , %{ &quot;id&quot; =&gt; 7 , &quot;name&quot; =&gt; &quot;Office Design Software&quot; } , %{ &quot;id&quot; =&gt; 8 , &quot;name&quot; =&gt; &quot;Desk Combination&quot; } , %{ &quot;id&quot; =&gt; 12 , &quot;name&quot; =&gt; &quot;Customizable Desk&quot; } , %{ &quot;id&quot; =&gt; 13 , &quot;name&quot; =&gt; &quot;Customizable Desk&quot; } ] , model : &quot;product.product&quot; , opts : [ offset : 5 , limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ] } } iex&gt; { :ok , result3 } = Odoo . prev ( odoo , result2 ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 1 , &quot;name&quot; =&gt; &quot;Restaurant Expenses&quot; } , %{ &quot;id&quot; =&gt; 2 , &quot;name&quot; =&gt; &quot;Hotel Accommodation&quot; } , %{ &quot;id&quot; =&gt; 3 , &quot;name&quot; =&gt; &quot;Virtual Interior Design&quot; } , %{ &quot;id&quot; =&gt; 4 , &quot;name&quot; =&gt; &quot;Virtual Home Staging&quot; } , %{ &quot;id&quot; =&gt; 5 , &quot;name&quot; =&gt; &quot;Office Chair&quot; } ] , model : &quot;product.product&quot; , opts : [ offset : 0 , limit : 5 , fields : [ &quot;name&quot; ] , order : &quot;id asc&quot; ] } }","ref":"Odoo.html#prev/2","title":"Odoo.prev/2","type":"function"},{"doc":"Read objects by id Return {:ok, objects_list} or {:error, message} Example iex&gt; { :ok , product } = Odoo . read ( odoo , &quot;product.product&quot; , [ 63 ] , [ fields : [ &quot;name&quot; , &quot;categ_id&quot; ] ] ) { :ok , % Odoo.Result { data : [ %{ &quot;id&quot; =&gt; 63 , &quot;name&quot; =&gt; &quot;mi mega producto3&quot; , &quot;categ_id&quot; =&gt; [ 1 , &quot;All&quot; ] } ] , model : &quot;product.product&quot; , opts : [ fields : [ &quot;name&quot; , &quot;categ_id&quot; ] ] } }","ref":"Odoo.html#read/4","title":"Odoo.read/4","type":"function"},{"doc":"Read and group objects ### Params :fields :domain :groupby :lazy :orderby :offset Example iex&gt; { :ok , result } = Odoo . read_group ( odoo , &quot;account.invoice&quot; , [ domain : [ [ &quot;date_invoice&quot; , &quot;&gt;=&quot; , &quot;2021-11-01&quot; ] ] , groupby : [ &quot;date_invoice:month&quot; ] , fields : [ &quot;number&quot; , &quot;partner_id&quot; ] , limit : 2 , lazy : true ] ) { :ok , % Odoo.Result { data : [ %{ &quot;__domain&quot; =&gt; [ &quot;&amp;&quot; , &quot;&amp;&quot; , [ &quot;date_invoice&quot; , &quot;&gt;=&quot; , &quot;2022-01-01&quot; ] , [ &quot;date_invoice&quot; , &quot;&lt;&quot; , &quot;2022-02-01&quot; ] , [ &quot;date_invoice&quot; , &quot;&gt;=&quot; , &quot;2021-11-01&quot; ] ] , &quot;date_invoice:month&quot; =&gt; &quot;enero 2022&quot; , &quot;date_invoice_count&quot; =&gt; 61 } , %{ &quot;__domain&quot; =&gt; [ &quot;&amp;&quot; , &quot;&amp;&quot; , [ &quot;date_invoice&quot; , &quot;&gt;=&quot; , &quot;2022-02-01&quot; ] , [ &quot;date_invoice&quot; , &quot;&lt;&quot; , &quot;2022-03-01&quot; ] , [ &quot;date_invoice&quot; , &quot;&gt;=&quot; , &quot;2021-11-01&quot; ] ] , &quot;date_invoice:month&quot; =&gt; &quot;febrero 2022&quot; , &quot;date_invoice_count&quot; =&gt; 32 } ] } }","ref":"Odoo.html#read_group/3","title":"Odoo.read_group/3","type":"function"},{"doc":"Search by domain. Return single id or id list. Params Arguments in keyword list format. Required opts: domain: list of list Optional arguments limit: int, max number of rows to return from odoo offset: int, offset over the default values to return Example iex&gt; { :ok , partner_ids } = Odoo . search ( odoo , &quot;res.partner&quot; , [ domain : [ [ &quot;name&quot; , &quot;ilike&quot; , &quot;Antonia%&quot; ] , [ &quot;customer&quot; , &quot;=&quot; , true ] , [ &quot;create_date&quot; , &quot;&gt;=&quot; , &quot;2021-06-01&quot; ] ] , limit : 5 , offset : 10 , order : &quot;name&quot; ] ) { :ok , % Odoo.Result { data : &#39;[44]&#39; , model : &quot;res.partner&quot; , opts : [ domain : [ [ &quot;name&quot; , &quot;ilike&quot; , &quot;Lorraine%&quot; ] , [ &quot;customer&quot; , &quot;=&quot; , true ] , [ &quot;create_date&quot; , &quot;&gt;=&quot; , &quot;2021-06-01&quot; ] ] ] } } Return one value is a single integer for the id Return more than one value is a list of integers Can also return {:error, message} if the operation fails.","ref":"Odoo.html#search/3","title":"Odoo.search/3","type":"function"},{"doc":"Example Search and read with default options (limit, domain, fields, offset and order) {:ok, res} = Odoo.search_read(odoo, &quot;res.partner&quot;) Put options to tune the query: { :ok , partners } = Odoo . search_read ( odoo , &quot;res.partner&quot; , [ limit : 1 , domain : [ [ &quot;name&quot; , &quot;ilike&quot; , &quot;Antonio&quot; ] ] , fields : [ &quot;name&quot; , &quot;street&quot; ] , offset : 11 , order : &quot;name asc&quot; ] ) { :ok , [ %{ &quot;id&quot; =&gt; 226 , &quot;name&quot; =&gt; &quot;Antonio Fulanito de tal&quot; , &quot;street&quot; =&gt; &quot;Calle principal 1&quot; } ] } Search and read active and archived records (by default odoo only return active records) { :ok , partners } = Odoo . search_read ( odoo , &quot;res.partner&quot; , [ fields : [ &quot;name&quot; ] , offset : 0 , limit : 10 , order : &quot;id&quot; , domain : [ [ &quot;active&quot; , &quot;in&quot; , [ true , false ] ] ] ] ) ` ` `","ref":"Odoo.html#search_read/3","title":"Odoo.search_read/3","type":"function"},{"doc":"Update objects by id Example iex&gt; { :ok , result } = Odoo . write odoo , &quot;product.product&quot; , [ 63 ] , [ name : &quot;Mega Pro 3&quot; ] { :ok , % Odoo.Result { data : true , model : &quot;product.product&quot; , opts : [ name : &quot;Mega Pro 3&quot; ] } } Example adding a many2many value to an odoo object : category_to_link_id = 9 { :ok , result } = Odoo . write ( odoo , &quot;res.partner&quot; , partner_ids , [ category_id : [ [ 4 , category_to_link_id ] ] ] )","ref":"Odoo.html#write/4","title":"Odoo.write/4","type":"function"},{"doc":"","ref":"Odoo.html#t:odoo_fields/0","title":"Odoo.odoo_fields/0","type":"type"},{"doc":"","ref":"Odoo.html#t:option/0","title":"Odoo.option/0","type":"type"},{"doc":"","ref":"Odoo.html#t:option_valid_for_read/0","title":"Odoo.option_valid_for_read/0","type":"type"},{"doc":"","ref":"Odoo.html#t:option_valid_for_read_group/0","title":"Odoo.option_valid_for_read_group/0","type":"type"},{"doc":"","ref":"Odoo.html#t:option_valid_for_search/0","title":"Odoo.option_valid_for_search/0","type":"type"},{"doc":"Behaviour for Odoo API http clients.","ref":"Odoo.Api.html","title":"Odoo.Api","type":"behaviour"},{"doc":"","ref":"Odoo.Api.html#callp/2","title":"Odoo.Api.callp/2","type":"function"},{"doc":"","ref":"Odoo.Api.html#c:callp/2","title":"Odoo.Api.callp/2","type":"callback"},{"doc":"","ref":"Odoo.Api.html#callp/3","title":"Odoo.Api.callp/3","type":"function"},{"doc":"","ref":"Odoo.Api.html#c:callp/3","title":"Odoo.Api.callp/3","type":"callback"},{"doc":"","ref":"Odoo.Api.html#t:cookie/0","title":"Odoo.Api.cookie/0","type":"type"},{"doc":"","ref":"Odoo.Api.html#t:message/0","title":"Odoo.Api.message/0","type":"type"},{"doc":"","ref":"Odoo.Api.html#t:payload/0","title":"Odoo.Api.payload/0","type":"type"},{"doc":"","ref":"Odoo.Api.html#t:response/0","title":"Odoo.Api.response/0","type":"type"},{"doc":"","ref":"Odoo.Api.html#t:url/0","title":"Odoo.Api.url/0","type":"type"},{"doc":"Struct to store formated response from http client","ref":"Odoo.HttpClientResponse.html","title":"Odoo.HttpClientResponse","type":"module"},{"doc":"Structure to contain result data from odoo and helpers","ref":"Odoo.Result.html","title":"Odoo.Result","type":"module"},{"doc":"Using offset and limit, return a new set of options to operate over next results page","ref":"Odoo.Result.html#next/1","title":"Odoo.Result.next/1","type":"function"},{"doc":"Return previous page (offset - limit)","ref":"Odoo.Result.html#prev/1","title":"Odoo.Result.prev/1","type":"function"},{"doc":"Struct to store Odoo session","ref":"Odoo.Session.html","title":"Odoo.Session","type":"module"},{"doc":"Sets locally the user context language The user is responsible to use the right language in the user context","ref":"Odoo.Session.html#set_locally_user_context_lang/2","title":"Odoo.Session.set_locally_user_context_lang/2","type":"function"}]